// Connections
sbit LED    at LATA4_bit;  // Dahili LED RA4 Pinine Bagli
sbit BUZZER at LATD0_bit;  // Buzzer RD0 Pinine Bagli

// Software SPI module connections*/
sbit MFRC522_CS  at RA0_bit;   // SDA
sbit SoftSPI_CLK at RA1_bit;   // SCK
sbit SoftSPI_SDO at RA2_bit;   // MOSI
sbit SoftSPI_SDI at RA3_Bit;   // MISO
sbit MFRC522_RST at RA5_bit;   // RST

sbit MFRC522_CS_Direction  at TRISA0_Bit;
sbit SoftSPI_CLK_Direction at TRISA1_Bit;
sbit SoftSPI_SDO_Direction at TRISA2_Bit;
sbit SoftSPI_SDI_Direction at TRISA3_Bit;
sbit MFRC522_RST_Direction at TRISA5_Bit;
// End Software SPI module connections

#include "RC522.c"        // RC522 RFID Ktphanesi
#include "LCD_I2C.c"      // LCD I2C Ktphanesi

unsigned long RC522_ID;
char txt[3];

void main() {
  // Port Giris-ikis Seimi (0:ikis, 1:Giris)
  TRISA=0b00000000; // [][][MFRC522_RST][LED][SoftSPI_SDI][SoftSPI_SDO][SoftSPI_CLK][MFRC522_CS]
  TRISB=0b00000000; // [][][][][][][SCK][SDA]
  TRISC=0b00000000; // [][][][][][][][]
  TRISD=0b00000000; // [][][][][][][][BUZZER]
  TRISE=0b00000000; // [][][][][][][][]

  // Port Analog-Dijital Giris Seimi (0:Dijital, 1:Analog)
  ANSELA=0b00000000; // [][][][][][][][]
  ANSELB=0b00000000; // [][][][][][][][]
  ANSELC=0b00000000; // [][][][][][][][]
  ANSELD=0b00000000; // [][][][][][][][]
  ANSELE=0b00000000; // [][][][][][][][]

  // Port Temizleme
  LATA=0x00;
  LATB=0x00;
  LATC=0x00;
  LATD=0x00;
  LATE=0x00;
  
  // I2C Hazirlama
  I2C1_Init(100000); // I2C LCD ktphanesi dahili I2C donanimi ile alismaktadir.
  
  Soft_SPI_Init();   // SPI hazirlama
  MFRC522_CS = 1;    // SlaveSelect (SS) RFID aktif
  MFRC522_Init();    // RC522 modl hazirlama
  delay_ms(1000);    // 1 saniye bekleme

  
  // LCD Ekran Hazirlama
  LCD_Init();                           // Ekrani hazirla
  LCD_Cmd(_LCD_CURSOR_OFF);             // Imleci kapat
  LCD_Cmd(_LCD_CLEAR);                  // Ekrani temizle
  Lcd_Out(1, 1,"   RFID-RC522   ");     // 1.Satir 1.Sutuna yaz
  Lcd_Out(2, 1,"ID:  00:00:00:00");     // 2.Satir 1.Sutuna yaz

  // Sonsuz Dongu
  while(1){
    RC522_ID=MFRC522_GetId();                            // RC522 ID oku
    
    if(RC522_ID){                                        // Bir ID okundu mu?
      BUZZER=1; delay_ms(100); BUZZER=0;                 // 100ms lik BUZZER sinyali
      
      ByteToHex(RC522_ID>>24, txt); Lcd_Out(2, 6,txt);   // ID'nin 1.Byte degerini LCD'ye yaz
      ByteToHex(RC522_ID>>16, txt); Lcd_Out(2, 9,txt);   // ID'nin 2.Byte degerini LCD'ye yaz
      ByteToHex(RC522_ID>>8 , txt); Lcd_Out(2, 12,txt);  // ID'nin 3.Byte degerini LCD'ye yaz
      ByteToHex(RC522_ID    , txt); Lcd_Out(2, 15,txt);  // ID'nin 4.Byte degerini LCD'ye yaz
      
      delay_ms(1000);                                    // 1 saniye bekleme
    }
  }
}