#line 1 "C:/Users/uemin/Desktop/mikroC/RC522 RFID Uygulamasi/main.c"

sbit LED at LATA4_bit;
sbit BUZZER at LATD0_bit;


sbit MFRC522_CS at RA0_bit;
sbit SoftSPI_CLK at RA1_bit;
sbit SoftSPI_SDO at RA2_bit;
sbit SoftSPI_SDI at RA3_Bit;
sbit MFRC522_RST at RA5_bit;

sbit MFRC522_CS_Direction at TRISA0_Bit;
sbit SoftSPI_CLK_Direction at TRISA1_Bit;
sbit SoftSPI_SDO_Direction at TRISA2_Bit;
sbit SoftSPI_SDI_Direction at TRISA3_Bit;
sbit MFRC522_RST_Direction at TRISA5_Bit;
#line 1 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
#line 107 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char serNum[5];

void Write_MFRC522(unsigned char addr, unsigned char val);
unsigned char Read_MFRC522(unsigned char addr);
void SetBitMask(unsigned char reg, unsigned char mask);
void ClearBitMask(unsigned char reg, unsigned char mask);
void AntennaOn(void);
void AntennaOff(void);
void MFRC522_Reset(void);
void MFRC522_Init(void);
unsigned char MFRC522_Request(unsigned char reqMode, unsigned char *TagType);
unsigned char MFRC522_ToCard(unsigned char command, unsigned char *sendData, unsigned char sendLen, unsigned char *backData, unsigned int *backLen);
unsigned char MFRC522_Anticoll(unsigned char *serNum);
void CalulateCRC(unsigned char *pIndata, unsigned char len, unsigned char *pOutData);
unsigned char MFRC522_SelectTag(unsigned char *serNum);
unsigned char MFRC522_Auth(unsigned char authMode, unsigned char BlockAddr, unsigned char *Sectorkey, unsigned char *serNum);
unsigned char MFRC522_Read(unsigned char blockAddr, unsigned char *recvData);
unsigned char MFRC522_Write(unsigned char blockAddr, unsigned char *writeData);
void MFRC522_Halt(void);
#line 133 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char Separate_hexP10(unsigned char val){
 val = val & 0xF0;
 val = val >> 4;

 if (val < 10)
 return val + 48;
 else
 return val + 55;
}
#line 149 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char Separate_hexP1(unsigned char val){
 val = val & 0x0F;
 if (val < 10)
 return val + 48;
 else
 return val + 55;
}
#line 163 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void Write_MFRC522(unsigned char addr, unsigned char val){
 MFRC522_CS = 0;


 Soft_SPI_Write((addr<<1)&0x7E);
 Soft_SPI_Write(val);

 MFRC522_CS = 1;
}
#line 180 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char Read_MFRC522(unsigned char addr){
 unsigned char val;

 MFRC522_CS = 0;


 Soft_SPI_Write(((addr<<1)&0x7E) | 0x80);
 val = Soft_SPI_Read(0x00);

 MFRC522_CS = 1;

 return val;
}
#line 200 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void SetBitMask(unsigned char reg, unsigned char mask){
 unsigned char tmp;

 tmp = Read_MFRC522(reg);
 Write_MFRC522(reg, tmp | mask);
}
#line 214 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void ClearBitMask(unsigned char reg, unsigned char mask){
 unsigned char tmp;
 tmp = Read_MFRC522(reg);
 Write_MFRC522(reg, tmp & (~mask));
}
#line 227 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void AntennaOn(void){
 unsigned char temp;

 temp = Read_MFRC522( 0x14 );
 if (!(temp & 0x03))
 SetBitMask( 0x14 , 0x03);
}
#line 242 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void AntennaOff(void){
 ClearBitMask( 0x14 , 0x03);
}
#line 253 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void MFRC522_Reset(void){
 Write_MFRC522( 0x01 ,  0x0F );
}
#line 264 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void MFRC522_Init(void){
 MFRC522_RST = 1;

 MFRC522_Reset();


 Write_MFRC522( 0x2A , 0x8D);
 Write_MFRC522( 0x2B , 0x3E);
 Write_MFRC522( 0x2D , 30);
 Write_MFRC522( 0x2C , 0);

 Write_MFRC522( 0x15 , 0x40);
 Write_MFRC522( 0x11 , 0x3D);

 AntennaOn();
}
#line 293 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_Request(unsigned char reqMode, unsigned char *TagType){
 unsigned char status;
 unsigned char backBits;

 Write_MFRC522( 0x0D , 0x07);

 TagType[0] = reqMode;
 status = MFRC522_ToCard( 0x0C , TagType, 1, TagType, &backBits);

 if ((status !=  0 ) || (backBits != 0x10))
 status =  2 ;

 return status;
}
#line 319 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_ToCard(unsigned char command, unsigned char *sendData, unsigned char sendLen, unsigned char *backData, unsigned int *backLen){
 unsigned char status =  2 ;
 unsigned char irqEn = 0x00;
 unsigned char waitIRq = 0x00;
 unsigned char lastBits;
 unsigned char n;
 unsigned char i;

 switch (command){
 case  0x0E :
 irqEn = 0x12;
 waitIRq = 0x10;
 break;
 case  0x0C :
 irqEn = 0x77;
 waitIRq = 0x30;
 break;
 default:
 break;
 }

 Write_MFRC522( 0x02 , irqEn|0x80);
 ClearBitMask( 0x04 , 0x80);
 SetBitMask( 0x0A , 0x80);

 Write_MFRC522( 0x01 ,  0x00 );


 for (i=0; i<sendLen; i++)
 Write_MFRC522( 0x09 , sendData[i]);


 Write_MFRC522( 0x01 , command);
 if (command ==  0x0C )
 SetBitMask( 0x0D , 0x80);


 i = 2000;
 do{


 n = Read_MFRC522( 0x04 );
 i--;
 }
 while ((i!=0) && !(n&0x01) && !(n&waitIRq));

 ClearBitMask( 0x0D , 0x80);

 if (i != 0){
 if(!(Read_MFRC522( 0x06 ) & 0x1B)){
 status =  0 ;
 if (n & irqEn & 0x01)
 status =  1 ;

 if (command ==  0x0C ){
 n = Read_MFRC522( 0x0A );
 lastBits = Read_MFRC522( 0x0C ) & 0x07;
 if (lastBits)
 *backLen = (n-1)*8 + lastBits;
 else
 *backLen = n*8;

 if (n == 0)
 n = 1;
 if (n >  16 )
 n =  16 ;


 for (i=0; i<n; i++)
 backData[i] = Read_MFRC522( 0x09 );
 }
 }
 else
 status =  2 ;
 }
 return status;
}
#line 404 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_Anticoll(unsigned char *serNum){
 unsigned char status;
 unsigned char i;
 unsigned char serNumCheck=0;
 unsigned char unLen;




 Write_MFRC522( 0x0D , 0x00);

 serNum[0] =  0x93 ;
 serNum[1] = 0x20;
 status = MFRC522_ToCard( 0x0C , serNum, 2, serNum, &unLen);

 if (status ==  0 ){

 for (i=0; i<4; i++)
 serNumCheck ^= serNum[i];

 if (serNumCheck != serNum[i])
 status =  2 ;
 }



 return status;
}
#line 438 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void CalulateCRC(unsigned char *pIndata, unsigned char len, unsigned char *pOutData){
 unsigned char i, n;

 ClearBitMask( 0x05 , 0x04);
 SetBitMask( 0x0A , 0x80);



 for (i=0; i<len; i++)
 Write_MFRC522( 0x09 , *(pIndata+i));

 Write_MFRC522( 0x01 ,  0x03 );


 i = 0xFF;
 do{
 n = Read_MFRC522( 0x05 );
 i--;
 }
 while ((i!=0) && !(n&0x04));


 pOutData[0] = Read_MFRC522( 0x22 );
 pOutData[1] = Read_MFRC522( 0x21 );
}
#line 469 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_SelectTag(unsigned char *serNum){
 unsigned char i;
 unsigned char status;
 unsigned char size;
 unsigned char recvBits;
 unsigned char buffer[9];



 buffer[0] =  0x93 ;
 buffer[1] = 0x70;
 for (i=0; i<5; i++)
 buffer[i+2] = *(serNum+i);

 CalulateCRC(buffer, 7, &buffer[7]);
 status = MFRC522_ToCard( 0x0C , buffer, 9, buffer, &recvBits);

 if ((status ==  0 ) && (recvBits == 0x18))
 size = buffer[0];
 else
 size = 0;

 return size;
}
#line 504 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_Auth(unsigned char authMode, unsigned char BlockAddr, unsigned char *Sectorkey, unsigned char *serNum){
 unsigned char status;
 unsigned int recvBits;
 unsigned char i;
 unsigned char buff[12];


 buff[0] = authMode;
 buff[1] = BlockAddr;
 for (i=0; i<6; i++)
 buff[i+2] = *(Sectorkey+i);

 for (i=0; i<4; i++)
 buff[i+8] = *(serNum+i);

 status = MFRC522_ToCard( 0x0E , buff, 12, buff, &recvBits);

 if ((status !=  0 ) || (!(Read_MFRC522( 0x08 ) & 0x08)))
 status =  2 ;

 return status;
}
#line 532 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_Read(unsigned char blockAddr, unsigned char *recvData){
 unsigned char status;
 unsigned int unLen;

 recvData[0] =  0x30 ;
 recvData[1] = blockAddr;
 CalulateCRC(recvData,2, &recvData[2]);
 status = MFRC522_ToCard( 0x0C , recvData, 4, recvData, &unLen);

 if ((status !=  0 ) || (unLen != 0x90))
 status =  2 ;

 return status;
}
#line 552 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
unsigned char MFRC522_Write(unsigned char blockAddr, unsigned char *writeData){
 unsigned char status;
 unsigned int recvBits;
 unsigned char i;
 unsigned char buff[18];

 buff[0] =  0xA0 ;
 buff[1] = blockAddr;
 CalulateCRC(buff, 2, &buff[2]);
 status = MFRC522_ToCard( 0x0C , buff, 4, buff, &recvBits);

 if ((status !=  0 ) || (recvBits != 4) || ((buff[0] & 0x0F) != 0x0A))
 status =  2 ;

 if (status ==  0 )
 {
 for (i=0; i<16; i++)
 buff[i] = *(writeData+i);

 CalulateCRC(buff, 16, &buff[16]);
 status = MFRC522_ToCard( 0x0C , buff, 18, buff, &recvBits);

 if ((status !=  0 ) || (recvBits != 4) || ((buff[0] & 0x0F) != 0x0A))
 status =  2 ;
 }

 return status;
}
#line 586 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/rc522.c"
void MFRC522_Halt(void){
 unsigned char status;
 unsigned int unLen;
 unsigned char buff[4];

 buff[0] =  0x50 ;
 buff[1] = 0;
 CalulateCRC(buff, 2, &buff[2]);

 status = MFRC522_ToCard( 0x0C , buff, 4, buff,&unLen);
}

unsigned long MFRC522_GetId(){
 unsigned char response;
 unsigned char str[ 16 ];
 unsigned long id=0;


 response = MFRC522_Request( 0x26 , str);

 response = MFRC522_Anticoll(str);
 memcpy(serNum, str, 5);

 if (response ==  0 ){
 id = serNum[0]; id<<=8;
 id += serNum[1]; id<<=8;
 id += serNum[2]; id<<=8;
 id += serNum[3];
 }
 else{
 MFRC522_Halt();
 delay_ms(50);
 }

 return id;
}
#line 1 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/lcd_i2c.c"
#line 21 "c:/users/uemin/desktop/mikroc/rc522 rfid uygulamasi/lcd_i2c.c"
const unsigned short HEX00=0x00;
const unsigned short HEX01=0x01;
const unsigned short HEX04=0x04;
const unsigned short HEX06=0x06;
const unsigned short HEX08=0x08;
const unsigned short HEX20=0x20;
const unsigned short HEX28=0x28;
const unsigned short HEX30=0x30;
const unsigned short HEX80=0x80;
const unsigned short HEX94=0x94;
const unsigned short HEXC0=0xC0;
const unsigned short HEXD4=0xD4;
const unsigned short HEXF0=0xF0;

void LCD_Cmd(char out_char) {
 char hi_n, lo_n;
 char rs = HEX00;

 hi_n = out_char & HEXF0;
 lo_n = (out_char << 4) & HEXF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();
 I2C1_Wr(hi_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(hi_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_stop();

 if(out_char == HEX01)
 Delay_ms(2);
}

void LCD_Chr(char row, char column, char out_char) {
 char hi_n, lo_n;
 char rs = HEX01;

 column--;
 switch(row){
 case 1:
 LCD_Cmd(HEX80+column);
 break;
 case 2:
 LCD_Cmd(HEXC0+column);
 break;
 case 3:
 LCD_Cmd(HEX94+column);
 break;
 case 4:
 LCD_Cmd(HEXD4+column);
 break;
 };

 hi_n = out_char & HEXF0;
 lo_n = (out_char << 4) & HEXF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();
 I2C1_Wr(hi_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(hi_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_stop();
}

void LCD_Chr_Cp(char out_char) {
 char hi_n, lo_n;
 char rs = HEX01;

 hi_n = out_char & HEXF0;
 lo_n = (out_char << 4) & HEXF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();
 I2C1_Wr(hi_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(hi_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(lo_n | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_stop();
}


void LCD_Init() {
 char rs = HEX00;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();

 Delay_10ms();
 Delay_10ms();
 Delay_10ms();

 I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();

 Delay_10ms();

 I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();

 Delay_10ms();

 I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_10ms();
 Delay_10ms();
 Delay_10ms();
 Delay_10ms();
 Delay_10ms();
 I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();

 Delay_10ms();

 I2C1_Wr(HEX20 | rs | HEX04 | HEX08);
 I2C1_Is_Idle();
 Delay_50us();
 I2C1_Wr(HEX20 | rs | HEX00 | HEX08);
 I2C1_Is_Idle();
 I2C1_Stop();

 Delay_10ms();

 LCD_Cmd(HEX28);
 LCD_Cmd(HEX06);
}

void LCD_Out(char row, char col, char *text) {
 while(*text)
 LCD_Chr(row, col++, *text++);
}

void LCD_Out_Cp(char *text) {
 while(*text)
 LCD_Chr_Cp(*text++);
}
#line 22 "C:/Users/uemin/Desktop/mikroC/RC522 RFID Uygulamasi/main.c"
unsigned long RC522_ID;
char txt[3];

void main() {

 TRISA=0b00000000;
 TRISB=0b00000000;
 TRISC=0b00000000;
 TRISD=0b00000000;
 TRISE=0b00000000;


 ANSELA=0b00000000;
 ANSELB=0b00000000;
 ANSELC=0b00000000;
 ANSELD=0b00000000;
 ANSELE=0b00000000;


 LATA=0x00;
 LATB=0x00;
 LATC=0x00;
 LATD=0x00;
 LATE=0x00;


 I2C1_Init(100000);

 Soft_SPI_Init();
 MFRC522_CS = 1;
 MFRC522_Init();
 delay_ms(1000);



 LCD_Init();
 LCD_Cmd( 0x0C );
 LCD_Cmd( 0x01 );
 Lcd_Out(1, 1,"   RFID-RC522   ");
 Lcd_Out(2, 1,"ID:  00:00:00:00");


 while(1){
 RC522_ID=MFRC522_GetId();
 if(RC522_ID){
 BUZZER=1; delay_ms(10); BUZZER=0;
 ByteToHex(RC522_ID>>24, txt); Lcd_Out(2, 6,txt);
 ByteToHex(RC522_ID>>16, txt); Lcd_Out(2, 9,txt);
 ByteToHex(RC522_ID>>8 , txt); Lcd_Out(2, 12,txt);
 ByteToHex(RC522_ID , txt); Lcd_Out(2, 15,txt);
 delay_ms(1000);
 }
 }
}
